
file.s = ProgramParameter()
If (ProgramParameter() = "START")
  isstartcode = #True
EndIf

If (file = "")
  MessageRequester("PBScript-Compiler", "Dieses Programm kann nur mit einer Script-Datei als Parameter aufgerufen werden."+Chr(10)+"Verwenden sie diesen Programm am besten als Tool in der PureBasic-IDE.")
  End
EndIf

*bytecode = PBSCompileScriptFile(file)
If (*bytecode = #Null)
  MessageRequester("PBScript-Compiler", PBSGetErrorText())
  End
EndIf
If (PBSOpenByteMemory(0, *bytecode) = #False)
  MessageRequester("PBScript-Compiler", PBSGetErrorText())
  End
EndIf


Global IsScriptRun
Global ThreadID
Global Dim ProcParam.PBSValue(0)
Global CountProcParam

value.PBSValue


Procedure.s GetTypeText(type)
  Select type
  Case #PBSType_Ascii:     ProcedureReturn "Ascii"
  Case #PBSType_Byte:      ProcedureReturn "Byte"
  Case #PBSType_Character: ProcedureReturn "Character"
  Case #PBSType_Double:    ProcedureReturn "Double"
  Case #PBSType_Float:     ProcedureReturn "Float"
  Case #PBSType_Integer:   ProcedureReturn "Integer"
  Case #PBSType_Long:      ProcedureReturn "Long"
  Case #PBSType_Quad:      ProcedureReturn "Quad"
  Case #PBSType_String:    ProcedureReturn "String"
  Case #PBSType_Unicode:   ProcedureReturn "Unicode"
  Case #PBSType_Word:      ProcedureReturn "Word"
  Case #PBSType_Structure: ProcedureReturn "Structure"
  EndSelect
EndProcedure


Procedure.s GetValueText(*value.PBSValue, isinput=#False)
  Select *value\type
  Case #PBSType_Ascii, #PBSType_Byte, #PBSType_Integer, #PBSType_Long, #PBSType_Quad, #PBSType_Unicode, #PBSType_Word
    ProcedureReturn Str(*value\quad)
  Case #PBSType_Character
    ProcedureReturn Str(*value\character)
  Case #PBSType_Float
    ProcedureReturn StrF(*value\float)
  Case #PBSType_Double
    ProcedureReturn StrD(*value\double)
  Case #PBSType_String
    If (isinput = #True)
      ProcedureReturn *value\string
    Else
      ProcedureReturn Chr(34)+*value\string+Chr(34)
    EndIf
  EndSelect
EndProcedure


Procedure InputValueText(*value.PBSValue)
  input.s = InputRequester("PBSScript-Compiler", "Setzte Wert auf:", GetValueText(*value,#True))
  If (input = "") And (*value\type <> #PBSType_String)
    ProcedureReturn #False
  EndIf
  Select *value\type
  Case #PBSType_Ascii, #PBSType_Byte, #PBSType_Integer, #PBSType_Long, #PBSType_Quad, #PBSType_Unicode, #PBSType_Word
    *value\quad = Val(input)
  Case #PBSType_Character
    *value\character = Val(input)
  Case #PBSType_Float
    *value\float = ValF(input)
  Case #PBSType_Double
    *value\double = ValD(input)
  Case #PBSType_String
    *value\string = input
  EndSelect
  ProcedureReturn #True
EndProcedure


Procedure AddStrucItem(name.s, struc.s)
  Protected value.PBSValue
  count = PBSGetStructureCountItems(0, struc)
  For i = 0 To count-1
    type = PBSGetStructureItemType(0, struc, i)
    If (type <> #PBSType_StructureUnion) And (type <> #PBSType_EndStructureUnion)
      newname.s = name+"\"+PBSGetStructureItemName(0, struc, i)
      value\type = type
      AddGadgetItem(1, -1, "("+GetTypeText(type)+")"+Chr(10)+newname+Chr(10)+GetValueText(value))
      If (type = #PBSType_Structure)
        AddStrucItem(newname, PBSGetStructureItemStruc(0, struc, i))
      EndIf
    EndIf
  Next
EndProcedure


Procedure StartCode(proc)
  Protected value.PBSValue
  If (proc = 0)
    PBSStartByteCode(0)
  Else
    name.s = StringField(GetGadgetItemText(0,proc),1,"(")
    PBSCallProcedure(0, name, value, CountProcParam, ProcParam())
  EndIf
  IsScriptRun = -1
  StatusBarText(0, 0, "Programm beendet", #PB_StatusBar_Center)
  DisableGadget(0, 0)
  If (proc > 0)
    MessageRequester("PBSScript-Compiler", "Rckgabe der Procedure:"+Chr(10)+GetValueText(value))
  EndIf
EndProcedure


Procedure CallProcedure(name.s)
  count = PBSGetProcedureCountParams(0, name)
  optio = PBSGetProcedureCountOptio(0, name)
  CountProcParam = count
  If (count = 0)
    ProcedureReturn #True
  EndIf
  
  ReDim ProcParam.PBSValue(count-1)
  For i = 0 To count-1
    ClearStructure(ProcParam(i), PBSValue)
    ProcParam(i)\type = PBSGetProcedureParamType(0, name, i)
  Next
  
  hei = 75+count*30
  If OpenWindow(1, 0, 0, 320, hei, "PBSScript-Compiler - Procedureaufruf", #PB_Window_SystemMenu|1, WindowID(0))
    EnableWindow_(WindowID(0), 0)
    
    AddKeyboardShortcut(1, #PB_Shortcut_Return, 10)
    AddKeyboardShortcut(1, #PB_Shortcut_Escape, 11)
    
    TextGadget(#PB_Any, 5, 5, 310, 15, "Procedure "+name+"()", #PB_Text_Center)
    Frame3DGadget(#PB_Any, 5, 20, 310, hei-55, "Parameter:")
    For i = 0 To count-1
      If (i < count-optio)
        check = CheckBoxGadget(#PB_Any, 15, 40+i*30, 18, 15, "")
        SetGadgetState(check, 1)
        DisableGadget(check, 1)
        TextGadget(#PB_Any, 33, 40+i*30, 57, 15, "("+GetTypeText(PBSGetProcedureParamType(0,name,i))+")")
      Else
        CheckBoxGadget(22+i*4, 15, 40+i*30, 75, 15, "("+GetTypeText(PBSGetProcedureParamType(0,name,i))+")")
        SetGadgetState(22+i*4, 1)
      EndIf
      StringGadget(20+i*4, 90, 37+i*30, 175, 20, GetValueText(ProcParam(i)), #PB_String_ReadOnly)
      ButtonGadget(21+i*4, 270, 37+i*30, 35, 20, "Set")
    Next
    ButtonGadget(10,  70, hei-25, 85, 20, "Aufruf")
    ButtonGadget(11, 165, hei-25, 85, 20, "Abbruch")
    
    
    Repeat
      event = WaitWindowEvent()
      
      If (event = #PB_Event_Gadget)
        egid = EventGadget()
        If (egid = 10)
          CloseWindow(1)
          EnableWindow_(WindowID(0), 1)
          ProcedureReturn #True
        ElseIf (egid = 11)
          quit = 1
        ElseIf (egid >= 21) And ((egid % 4) = 1)
          idx = (egid-21)/4
          If InputValueText(ProcParam(idx))
            SetGadgetText(egid-1, GetValueText(ProcParam(idx)))
          EndIf
        ElseIf (egid >= 22) And ((egid % 4) = 2)
          idx = (egid-22)/4
          get = GetGadgetState(egid)
          HideGadget(egid-1, 1-get)
          HideGadget(egid-2, 1-get)
          If (get = 0)
            For i = idx+1 To count-1
              HideGadget(20+i*4, 1)
              HideGadget(21+i*4, 1)
              SetGadgetState(22+i*4, 0)
            Next
            CountProcParam = idx
          Else
            For i = count-optio To idx-1
              HideGadget(20+i*4, 0)
              HideGadget(21+i*4, 0)
              SetGadgetState(22+i*4, 1)
            Next
            CountProcParam = idx+1
          EndIf
        EndIf
      EndIf
      
      If (event = #PB_Event_Menu)
        emid = EventMenu()
        If (emid = 10)
          CloseWindow(1)
          EnableWindow_(WindowID(0), 1)
          ProcedureReturn #True
        ElseIf (emid = 11)
          quit = 1
        EndIf
      EndIf
      
      If (event = #PB_Event_CloseWindow)
        quit = 1
      EndIf
      
    Until quit
    
    CloseWindow(1)
    EnableWindow_(WindowID(0), 1)
  EndIf
  ProcedureReturn #False
EndProcedure


If OpenWindow(0, 0, 0, 450, 300, "PBScript-Compiler", #PB_Window_MinimizeGadget|1)
  AddKeyboardShortcut(0, #PB_Shortcut_Escape, 11)
  
  If CreateStatusBar(0, WindowID(0))
    AddStatusBarField(450)
    StatusBarText(0, 0, "Script geladen", #PB_StatusBar_Center)
  EndIf
  
  TextGadget(#PB_Any, 5, 5, 160, 15, "Alle Proceduren im Script:")
  ListViewGadget(0, 5, 20, 160, 275-StatusBarHeight(0))
  AddGadgetItem(0, -1, "--- StartCode ---")
  count = PBSGetCountProcedures(0)
  For i = 0 To count-1
    AddGadgetItem(0, -1, PBSGetProcedureName(0, i)+"()")
  Next
  
  TextGadget(#PB_Any, 175, 5, 270, 15, "Alle global Variablen im Script:")
  ListIconGadget(1, 175, 20, 270, 275-StatusBarHeight(0), "Typ", 60, #PB_ListIcon_FullRowSelect)
  AddGadgetColumn(1, 1, "Name", 100)
  AddGadgetColumn(1, 2, "Wert", 85)
  count = PBSGetCountVariables(0)
  For i = 0 To count-1
    name.s = PBSGetVariableName(0, i)
    type = PBSGetVariableType(0,name)
    value\type = type
    AddGadgetItem(1, -1, "("+GetTypeText(type)+")"+Chr(10)+name+Chr(10)+GetValueText(value))
    If (type = #PBSType_Structure)
      AddStrucItem(name, PBSGetVariableStruc(0,name))
    EndIf
  Next
  
  If (isstartcode = #True)
    DisableGadget(0, 1)
    IsScriptRun = 1
    StatusBarText(0, 0, "Das Programm luft...", #PB_StatusBar_Center)
    ThreadID = CreateThread(@StartCode(), 0)
  EndIf
  
  
  Repeat
    event = WaitWindowEvent(100)
    
    If (IsScriptRun <> 0)
      If (ElapsedMilliseconds() >= Time)
        If (IsScriptRun = -1)
          IsScriptRun = 0
        EndIf
        count = CountGadgetItems(1)
        For i = 0 To count-1
          name.s = GetGadgetItemText(1,i,1)
          If (PBSGetVariableType(0, name) <> #PBSType_Structure)
            PBSGetVariableValue(0, name, value)
            SetGadgetItemText(1, i, GetValueText(value), 2)
          EndIf
        Next
        Time = ElapsedMilliseconds()+100
      EndIf
    EndIf
    
    If (event = #PB_Event_Gadget)
      egid = EventGadget()
      If (EventType() = #PB_EventType_LeftDoubleClick)
        If (egid = 0)
          proc = GetGadgetState(0)
          If (proc > 0)
            If (CallProcedure(StringField(GetGadgetItemText(0,proc),1,"(")) = #False)
              proc = -1
            EndIf
          EndIf
          If (proc > -1)
            DisableGadget(0, 1)
            IsScriptRun = 1
            StatusBarText(0, 0, "Das Programm luft...", #PB_StatusBar_Center)
            ThreadID = CreateThread(@StartCode(), proc)
          EndIf
        ElseIf (egid = 1)
          If (IsScriptRun = 0)
            get = GetGadgetState(1)
            name.s = GetGadgetItemText(1,get,1)
            If (PBSGetVariableType(0, name) <> #PBSType_Structure)
              PBSGetVariableValue(0, name, value)
              If InputValueText(value)
                PBSSetVariableValue(0, name, value)
                SetGadgetItemText(1, get, GetValueText(value), 2)
              EndIf
            EndIf
          EndIf
        EndIf
      EndIf
    EndIf
    
    If (event = #PB_Event_Menu)
      emid = EventMenu()
      If (emid = 11)
        quit = 1
      EndIf
    EndIf
    
    If (event = #PB_Event_CloseWindow)
      quit = 1
    EndIf
    
  Until quit
EndIf

; IDE Options = PureBasic 4.40 (Windows - x86)
; EnableThread
; Executable = PBScript-Compiler.exe
; SubSystem = UserLibThreadSafe
; DisableDebugger